// Copyright (c) 2012 Cloudera, Inc.  All rights reserved.
define([], function () {

	/**
	 * Encapsulates the post processing step when an AJAX call to get
	 * the latest Add Hosts Install Details.
	 *
	 * options = {
	 *    detailsDialogSelector: "#someId"
	 * };
	 */
	return function(options) {
		var $lastSectionWithError,
			$lastSection, $elem,
			$dialog = $(options.detailsDialogSelector),
			$modalHeader = $dialog.find(".modal-header"),
			$modalBody = $dialog.find(".modal-body");

		// Mark all the sections starting from the rollback section,
		// plus the one just before the the rollback section as errors.
		$modalBody.find("h3").each(function(i, elem) {
			$elem = $(elem);
			if ($elem.is(".node-progress-ROLLBACK")) {
				$lastSectionWithError = $lastSection;
				if ($lastSectionWithError) {
					$lastSectionWithError.addClass("error");
				}
			}
			$lastSection = $elem;
		});

		// Move important attributes from the dialog body to the dialog header.
		// The content of the dialog header is always visible.
		$modalHeader.find(".currentState").html($modalBody.find(".currentState").html());
		$modalHeader.find(".failedState").html($modalBody.find(".failedState").html());

		// Remove these attributes from the dialog body.
		$modalBody.find(".currentState").remove();
		$modalBody.find(".failedState").remove();

		// Optional Cleanup.
		$lastSection = null;
		$lastSectionWithError = null;
		$elem = null;
		$modalHeader = null;
		$modalBody = null;
	};
});
