// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/Util","cloudera/common/Humanize","cloudera/cmf/include/DataTableColumnRenderer","cloudera/cmf/include/HeartbeatDuration","cloudera/common/spec/I18nSpec"],function(e,t,n,r,i){describe("DataTableColumnRenderer Tests",function(){var r=e.getServerNow();window.resources===undefined&&(window.resources={});var i={text:"Good",tag:"good"},s={text:"Running",tag:"RUNNING"};beforeEach(function(){spyOn(e,"getServerNow").andReturn(new Date(1e3)),spyOn(t,"getTimezoneDelta").andReturn(0)}),afterEach(function(){}),it("should render a checkbox",function(){var e={id:"foo"},t=n.renderCheckbox(e),r='<label><input type="checkbox" name="id" value="foo"></label>';expect(t).toEqual(r)}),it("should render a selected checkbox",function(){var e={id:"foo",selected:!0},t=n.renderCheckbox(e),r='<label><input type="checkbox" name="id" value="foo" checked="checked"></label>';expect(t).toEqual(r)}),it("should render a role",function(){var e={id:"1",serviceId:"7",roleName:"NameNode1"},t=n.renderRole(e),r="NameNode1";expect(t).toEqual(r)}),it("should render a roleType",function(){var e={roleType:"NAMENODE"},t=n.renderRoleType(e),r="NAMENODE";expect(t).toEqual(r)}),it("should render a role link",function(){var e={id:3,serviceId:"1",roleName:"NameNode1"},t=n.renderRoleLink(e),r='<a href="/cmf/services/1/instances/3/status"><i></i> NameNode1</a>';expect(t).toEqual(r)}),it("should render a role name",function(){var e={roleName:"NameNode1"},t=n.renderRole(e),r="NameNode1";expect(t).toEqual(r)}),it("should render a host name",function(){var e={id:1,hostName:"localhost",hostId:"localhost"},t=n.renderHost(e),r="localhost";expect(t).toEqual(r)}),it("should render a host name + hostId when they are different",function(){var e={id:1,hostName:"air",hostId:"localhost"},t=n.renderHost(e),r="air (localhost)";expect(t).toEqual(r)}),it("should render a host link",function(){var e={id:1,hostName:"air",hostId:"localhost",hostUrl:"/cmf/hardware/hosts/100/status"},t=n.renderHostLink(e),r='<a href="/cmf/hardware/hosts/1/status"><i></i> air (localhost)</a>';expect(t).toEqual(r)}),it("should render an IP Address",function(){var e={ipAddress:"127.0.0.1"},t=n.renderIP(e),r="127.0.0.1";expect(t).toEqual(r)}),it("should render a rack",function(){var e={rackId:"/default"},t=n.renderRack(e),r="/default";expect(t).toEqual(r)}),it("should render a health",function(){var e={health:{text:"Good",tag:"good"}},t=n.renderHealth(e),r='<span class="goodHealth"><span title="Good" class="icon"></span>Good</span>';expect(t).toEqual(r)}),it("should render a role state",function(){var e={roleState:{text:"Running",tag:"RUNNING"}},t=n.renderRoleState(e),r='<span class="RUNNINGState"><span title="Running" class="icon"></span>Running</span>';expect(t).toEqual(r)}),it("should render a date",function(){var e=10,t=n.renderDate(e),r=moment(e).format("LLL");expect(t).toEqual(r)});var o=function(e,t){var r={lastSeen:e},i=n.renderHeartbeat(r);expect(i).toMatch(t)};it("should render a heart beat",function(){var t=e.getServerNow();o(t,'0.00s ago<span class="hidden filterValue">0s-30s</span>')}),it("should render a heart beat with a filter value",function(){var t=e.getServerNow();o(t,"0s-30s"),o(new Date(t.getTime()-45e3),"30s-1m"),o(new Date(t.getTime()-9e4),"1m-2m"),o(new Date(t.getTime()-18e4),"2m-5m"),o(new Date(t.getTime()-36e4),"5m-10m"),o(new Date(t.getTime()-72e4),"10m+"),o(new Date(t.getTime()-72e5),"10m+")}),it("should render last seen",function(){var e={lastSeen:0},t=n.renderLastSeen(e),r="0";expect(t).toEqual(r)}),it("should render number of cores",function(){var e={numCores:3},t=n.renderNumCores(e),r="3";expect(t).toEqual(r)}),it("should render disk usage",function(){var e={space:{used:3,total:100}},t=n.renderDiskUsage(e),r='<div class="CapacityUsage priorityLow"><span class="reading">3 B / 100 B</span><span class="bar" style="width: 3%; "></span><span class="hidden filterValue">priorityLow</span></div>';expect(t).toEqual(r)}),it("should render load average",function(){var e={loadAverage:[.1,.2,.3]},t=n.renderLoadAverage(e),r="<table class='innerTable'><tbody><tr><td>0.1</td><td>0.2</td><td>0.3</td></tr></tbody></table>";expect(t).toEqual(r)}),it("should render physical memory",function(){var e={physicalMemory:{used:3,total:100}},t=n.renderPhysicalMemory(e),r='<div class="CapacityUsage priorityLow"><span class="reading">3 B / 100 B</span><span class="bar" style="width: 3%; "></span><span class="hidden filterValue">priorityLow</span></div>';expect(t).toEqual(r)}),it("should render virtual memory",function(){var e={virtualMemory:{used:55,total:100}},t=n.renderVirtualMemory(e),r='<div class="CapacityUsage priorityMed"><span class="reading">55 B / 100 B</span><span class="bar" style="width: 55%; "></span><span class="hidden filterValue">priorityMed</span></div>';expect(t).toEqual(r)}),it("should check match",function(){var e="foobar",t="bar",r=!0;expect(n.match(e,t,!r)).toEqual(!0),expect(n.match(e,t,r)).toEqual(!1)}),it("should set pagination",function(){var e={};n.setPagination(e,!0,30),expect(e.sPaginationType).toEqual("full_numbers"),expect(e.iDisplayLength).toEqual(30),expect(e.bPaginate).toEqual(!0),expect(e.bLengthChange).toEqual(!0)}),it("should set pagination to false",function(){var e={};n.setPagination(e,!1,30),expect(e.sPaginationType).toEqual(null),expect(e.iDisplayLength).toEqual(null),expect(e.bPaginate).toEqual(!1),expect(e.bLengthChange).toEqual(!0)}),it("should render a link",function(){var e="foo",t="http://www.example.com",r="dummyTitle",i=n.renderLink(t,e,r),s='<a href="http://www.example.com" title="dummyTitle">foo</a>';expect(i).toEqual(s)}),it("should render an actual maintenance mode icon",function(){var e={actual:!0},t=n.renderMaintenanceMode(e),r='Yes <span class="hidden">yes</span><span class="maintenanceIconActual16x16"></span>';expect(t).toEqual(r)}),it("should render an effective maintenance mode icon",function(){var e={actual:!1,effective:!0},t=n.renderMaintenanceMode(e),r='Yes <span class="hidden">yes</span><span class="maintenanceIconEffective16x16"></span>';expect(t).toEqual(r)}),it("should render a maintenance mode empty string",function(){var e={actual:!1},t=n.renderMaintenanceMode(e),r='<span class="hidden">no</span>';expect(t).toEqual(r)}),it("should render a commission state column",function(){var e={text:"Decommissioned",tag:"commission-state-decommissioned"},t=n.renderCommissionState(e),r='Decommissioned<span class="hidden">commission-state-decommissioned</span>';expect(t).toEqual(r)}),it("should render a commission state column with no visible data",function(){var e={text:"Not Decommissioned",tag:"commission-state-commissioned"},t=n.renderCommissionState(e),r='<span class="hidden">commission-state-commissioned</span>';expect(t).toEqual(r)}),it("should render nothing",function(){var e={},t;for(t in n)if(n.hasOwnProperty(t)&&$.isFunction(n[t])&&t.indexOf("render")===0){var r=n[t](e),i="";t==="renderHeartbeat"&&(i="None"),expect(r+" "+t).toEqual(i+" "+t)}}),it("should render a pagination menu",function(){var e=n.getPaginationMenu(),t='Display <select class="pagination span1"><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="100">100</option><option value="250">250</option><option value="-1">All</option></select> Entries';expect(e).toEqual(t)})})})